import processing.pdf.*;

boolean record;

void setup() {
  //set the size of the output
  size(702,497, P3D);
  noLoop();
}
int X = 0;
int Y = 0;
int Z = 0;
int i;
int j;
int k = 0;
float alfalfa;
float indTranslation;

void draw() {
  noStroke();
  //intitialize PDF writing
  beginRaw(PDF, "output10.pdf");

  //turn the output in perspective
  float fov = PI/2.5;
  float cameraZ = (height/2.0) / tan(PI * fov / 360.0);
  perspective(fov, float(width)/float(height),cameraZ/10.0, cameraZ*10.0);
  translate(-700, -1150, 0);
  rotateX(-PI/11);
  rotateY(PI/5);

  //set the alpha value, the "further" away, the lower
  for (i = -15; i < 30; i = i+1) {
    alfalfa = 123-(i*100/54)-(j*100/54);
    if(alfalfa>100){
      alfalfa = 100;
    }
    for (j = -2; j < 38; j = j+1) {
      //draw a box and a flower
      flowerPower();
      k=0;
      translate(0,100);
    }
    if(j==38){
      translate(0,-4000);
    }
    translate(100,0);
  }
  //finalize pdf
  endRaw();
  record = false;
  println("done");

}

void flowerPower(){
  //put the flower in the middle of the box
  translate(42.5,42.5);
  fill(random(255),random(255),random(255),68-(j+2-10)-(i+15-10));
  box(100);

  translate(-42.5,-42.5);
  // make the output a little more random
  // in order not to get straight lines of flowers
  indTranslation=random(30-(i/3.5)-(j/3.5));
  translate(indTranslation,indTranslation);
  while (k<10){
    fill(random(255),random(255),random(255),alfalfa);
    beginShape();
    //2 beziercurvers that define a "leaf"
    vertex(20,20,20);
    bezierVertex(random(100-(j/6)),random(100-(j/6)),random(100-(j/6)),random(100-(j/6)),random(100-(j/6)),random(100-(j/6)),42.5,42.5,42.5);
    bezierVertex(42.5,42.5,42.5,random(100-(j/6)),random(100-(j/6)),random(100-(j/6)),random(100-(j/6)),random(100-(j/6)),random(100-(j/6)));
    endShape();
    k=k+1;
  }
  translate(-indTranslation,-indTranslation);
}
